> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.meshapi.ai/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.meshapi.ai/_mcp/server.

# Vector Search

POST https://api.meshapi.ai/v1/files/search
Content-Type: application/json

Reference: https://developers.meshapi.ai/api-reference/mesh-api/rag/vector-search

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: openapi
  version: 1.0.0
paths:
  /v1/files/search:
    post:
      operationId: vector-search
      summary: Vector Search
      tags:
        - rag
      parameters:
        - name: Authorization
          in: header
          description: Bearer authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SearchResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SearchRequest'
servers:
  - url: https://api.meshapi.ai
    description: Production Server
components:
  schemas:
    SearchRequest:
      type: object
      properties:
        query:
          type: string
        top_k:
          type: integer
          default: 5
        file_ids:
          type:
            - array
            - 'null'
          items:
            type: string
          description: Restrict to these file IDs
        filter:
          type:
            - object
            - 'null'
          additionalProperties:
            description: Any type
          description: Match on any metadata key/value pairs
        date_from:
          type:
            - integer
            - 'null'
          description: Unix timestamp — only chunks created after this
        date_to:
          type:
            - integer
            - 'null'
          description: Unix timestamp — only chunks created before this
      required:
        - query
      title: SearchRequest
    SearchResult:
      type: object
      properties:
        score:
          type: number
          format: double
        text:
          type: string
        parent_text:
          type: string
        file_id:
          type:
            - string
            - 'null'
        file_name:
          type:
            - string
            - 'null'
        file_type:
          type:
            - string
            - 'null'
        mime_type:
          type:
            - string
            - 'null'
        chunk_index:
          type:
            - integer
            - 'null'
        created_at:
          type:
            - integer
            - 'null'
        metadata:
          type: object
          additionalProperties:
            description: Any type
      required:
        - score
        - text
        - parent_text
        - file_id
        - file_name
        - file_type
        - mime_type
        - chunk_index
        - created_at
        - metadata
      title: SearchResult
    SearchResponse:
      type: object
      properties:
        results:
          type: array
          items:
            $ref: '#/components/schemas/SearchResult'
      required:
        - results
      title: SearchResponse
    ValidationErrorLocItems:
      oneOf:
        - type: string
        - type: integer
      title: ValidationErrorLocItems
    ValidationErrorCtx:
      type: object
      properties: {}
      title: ValidationErrorCtx
    ValidationError:
      type: object
      properties:
        loc:
          type: array
          items:
            $ref: '#/components/schemas/ValidationErrorLocItems'
        msg:
          type: string
        type:
          type: string
        input:
          description: Any type
        ctx:
          $ref: '#/components/schemas/ValidationErrorCtx'
      required:
        - loc
        - msg
        - type
      title: ValidationError
    HTTPValidationError:
      type: object
      properties:
        detail:
          type: array
          items:
            $ref: '#/components/schemas/ValidationError'
      title: HTTPValidationError
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

```

## Examples

### Example response



**Request**

```json
undefined
```

**Response**

```json
{
  "results": [
    {
      "score": 0.92,
      "text": "Milestone 1 is the design review, followed by implementation.",
      "parent_text": "The project milestones are design review, implementation, and launch.",
      "file_id": "file_01JZ0S3N6M8ZQ8DGK9VY1R2H3T",
      "file_name": "project_proposal.pdf",
      "file_type": "pdf",
      "mime_type": "application/pdf",
      "chunk_index": 3,
      "created_at": 1783001227,
      "metadata": {
        "page": 2
      }
    }
  ]
}
```

**SDK Code**

```python Example response
import requests

url = "https://api.meshapi.ai/v1/files/search"

headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, headers=headers)

print(response.json())
```

```javascript Example response
const url = 'https://api.meshapi.ai/v1/files/search';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: undefined
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Example response
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.meshapi.ai/v1/files/search"

	req, _ := http.NewRequest("POST", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example response
require 'uri'
require 'net/http'

url = URI("https://api.meshapi.ai/v1/files/search")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'

response = http.request(request)
puts response.read_body
```

```java Example response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.meshapi.ai/v1/files/search")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .asString();
```

```php Example response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.meshapi.ai/v1/files/search', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Example response
using RestSharp;

var client = new RestClient("https://api.meshapi.ai/v1/files/search");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
IRestResponse response = client.Execute(request);
```

```swift Example response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.meshapi.ai/v1/files/search")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Example request



**Request**

```json
{
  "query": "What are the project milestones?",
  "top_k": 5,
  "file_ids": [
    "file_01JZ0S3N6M8ZQ8DGK9VY1R2H3T"
  ]
}
```

**Response**

```json
{
  "results": [
    {
      "score": 0.92,
      "text": "Milestone 1 is the design review, followed by implementation.",
      "parent_text": "The project milestones are design review, implementation, and launch.",
      "file_id": "file_01JZ0S3N6M8ZQ8DGK9VY1R2H3T",
      "file_name": "project_proposal.pdf",
      "file_type": "pdf",
      "mime_type": "application/pdf",
      "chunk_index": 3,
      "created_at": 1783001227,
      "metadata": {
        "page": 2
      }
    }
  ]
}
```

**SDK Code**

```python Example request
import requests

url = "https://api.meshapi.ai/v1/files/search"

payload = {
    "query": "What are the project milestones?",
    "top_k": 5,
    "file_ids": ["file_01JZ0S3N6M8ZQ8DGK9VY1R2H3T"]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Example request
const url = 'https://api.meshapi.ai/v1/files/search';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"query":"What are the project milestones?","top_k":5,"file_ids":["file_01JZ0S3N6M8ZQ8DGK9VY1R2H3T"]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Example request
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.meshapi.ai/v1/files/search"

	payload := strings.NewReader("{\n  \"query\": \"What are the project milestones?\",\n  \"top_k\": 5,\n  \"file_ids\": [\n    \"file_01JZ0S3N6M8ZQ8DGK9VY1R2H3T\"\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example request
require 'uri'
require 'net/http'

url = URI("https://api.meshapi.ai/v1/files/search")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"query\": \"What are the project milestones?\",\n  \"top_k\": 5,\n  \"file_ids\": [\n    \"file_01JZ0S3N6M8ZQ8DGK9VY1R2H3T\"\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Example request
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.meshapi.ai/v1/files/search")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"query\": \"What are the project milestones?\",\n  \"top_k\": 5,\n  \"file_ids\": [\n    \"file_01JZ0S3N6M8ZQ8DGK9VY1R2H3T\"\n  ]\n}")
  .asString();
```

```php Example request
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.meshapi.ai/v1/files/search', [
  'body' => '{
  "query": "What are the project milestones?",
  "top_k": 5,
  "file_ids": [
    "file_01JZ0S3N6M8ZQ8DGK9VY1R2H3T"
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Example request
using RestSharp;

var client = new RestClient("https://api.meshapi.ai/v1/files/search");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"query\": \"What are the project milestones?\",\n  \"top_k\": 5,\n  \"file_ids\": [\n    \"file_01JZ0S3N6M8ZQ8DGK9VY1R2H3T\"\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Example request
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "query": "What are the project milestones?",
  "top_k": 5,
  "file_ids": ["file_01JZ0S3N6M8ZQ8DGK9VY1R2H3T"]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.meshapi.ai/v1/files/search")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```